#include <bits/stdc++.h>
#define int long long
#define mp make_pair
#define PII pair<int, int>
#define fi first
#define se second
using namespace std;

const int inf = 1LL << 60;
const int NMAX = 100005;

int len[2], a[2][NMAX], sum[2][NMAX];
int Q, S;
PII inter[NMAX];
int mn[4*NMAX], lazy[4*NMAX];

void Read()
{
	cin >> len[0] >> len[1] >> S;
	assert(len[0] <= NMAX - 5);
	assert(len[1] <= NMAX - 5);
	for (int j = 0; j <= 1; j++)
		for (int i = 1; i <= len[j]; i++) 
			{
				cin >> a[j][i];
				assert(0 <= a[j][i] && a[j][i] <= 2*S);
				sum[j][i] = sum[j][i - 1] + a[j][i];
			}
	cin >> Q;
	assert(Q <= NMAX - 5);
}

void DOWN(int nod, int st, int dr)
{
	mn[nod] += lazy[nod];
	if (st < dr)
	{
		lazy[2*nod] += lazy[nod];
		lazy[2*nod + 1] += lazy[nod];
	}
	lazy[nod] = 0;
}

void Update(int nod, int st, int dr, int l, int r, int val)
{
	if (l <= st && dr <= r) lazy[nod] += val;
	else
	{
		int mij = (st + dr) / 2;

		DOWN(nod, st, dr);

		if (l <= mij) Update(2*nod, st, mij, l, r, val);
		if (r > mij) Update(2*nod + 1, mij + 1, dr, l, r, val);

		DOWN(2*nod, st, mij);
		DOWN(2*nod + 1, mij + 1, dr);

		mn[nod] = min(mn[2*nod], mn[2*nod + 1]);
	}
}

PII IntervalPoints(int st, int dr)
{
	int l = 0, r = len[1];
	int indx = len[1] + 1, indy = -1;

	//indx
	while (l <= r)
	{
		int mij = (l + r) / 2;

		if (st <= sum[1][mij])
		{
			indx = mij;
			r = mij - 1;
		}
		else l = mij + 1;
	}

	//indy
	l = 0; r = len[1];
	while (l <= r)
	{
		int mij = (l + r) / 2;

		if (sum[1][mij] <= dr)
		{
			indy = mij;
			l = mij + 1;
		}
		else r = mij - 1;
	}

	return mp(indx, indy);
	/*int indx = lower_bound(sum[1], sum[1] + len[1] + 1, st) - sum[1];
	int indy = lower_bound(sum[1], sum[1] + len[1] + 1, dr) - sum[1];
	if (indx > len[1] || sum[1][indx] > dr) return mp(0, -1);
	if (indy > len[1] || sum[1][indy] > dr) indy--;

	return mp(indx, indy);*/
}

PII PointsInterval(int val)
{
	int l = 1, r = len[0];
	int indx = len[0] + 1, indy = -1;

	//indx
	while (l <= r)
	{
		int mij = (l + r) / 2;

		if (inter[mij].fi <= val && val <= inter[mij].se)
		{
			indx = mij;
			r = mij - 1;
		}
		else if (inter[mij].se < val) l = mij + 1;
		else r = mij - 1;
	}

	//indy
	l = 1; r = len[0];
	while (l <= r)
	{
		int mij = (l + r) / 2;

		if (inter[mij].fi <= val && val <= inter[mij].se)
		{
			indy = mij;
			l = mij + 1;
		}
		else if (inter[mij].se < val) l = mij + 1;
		else r = mij - 1;
	}

	return mp(indx, indy);
}

void UpdInter(int poz, int op)
{
	PII aux = IntervalPoints(inter[poz].fi, inter[poz].se);
	Update(1, 1, len[0], poz, poz, op*max(0LL, aux.se - aux.fi + 1));
}

void UpdPoints(int poz, int op)
{
	PII aux = PointsInterval(sum[1][poz]);
	if (aux.fi <= aux.se) Update(1, 1, len[0], aux.fi, aux.se, op);
}

void Remake(int poz, int x, int y)
{
	if (x > y) swap(x, y);

	if (poz == 0) //remake intervals
	{
		UpdInter(x, -1); UpdInter(y, -1);

		swap(a[poz][x], a[poz][y]);
		for (int i = x; i <= y; i++) 
			{
				sum[poz][i] = sum[poz][i - 1] + a[poz][i];
				inter[i] = mp(sum[poz][i] - S, S + sum[poz][i - 1]);
			}

		UpdInter(x, 1); UpdInter(y, 1);
	}
	else //remake points
	{
		UpdPoints(x, -1); UpdPoints(y, -1);

		swap(a[poz][x], a[poz][y]);
		for (int i = x; i <= y; i++) sum[poz][i] = sum[poz][i - 1] + a[poz][i];

		UpdPoints(x, 1); UpdPoints(y, 1);
	}

}

void Prep()
{
	for (int i = 1; i <= len[0]; i++) inter[i] = mp(sum[0][i] - S, S + sum[0][i - 1]);
	for (int i = 0; i <= len[1]; i++) //update aint
	{
		PII aux = PointsInterval(sum[1][i]);
		if (aux.fi <= aux.se) Update(1, 1, len[0], aux.fi, aux.se, 1);
	}
}

int32_t main()
{
	freopen("bfs.in", "r", stdin);
	freopen("bfs.out", "w", stdout);
	cin.sync_with_stdio(false);

	Read();
	Prep();

	assert(mn[1] + lazy[1] > 0);
	while (Q--)
	{
		char C;
		int x, y;
		cin >> C >> x >> y;

		int poz = 0;
		if (C == 'F') poz = 1;

		assert(1 <= x && 1 <= y && x <= len[poz] && y <= len[poz]);
		Remake(poz, x ,y);

		if (mn[1] + lazy[1] == 0) cout << "0\n";
		else cout << "1\n";
	}
	return 0;
}
