#include <bits/stdc++.h>

using namespace std;
const int kMod = 1e9 + 7;

void add_to(int &a, int b) {
    a += b;
    if (a >= kMod) 
        a -= kMod;
}
int mul(int a, int b) {
    return 1LL * a * b % kMod;
}

vector<int> SeenA, SeenB, PlayA, PlayB;
int n;
const int kMaxN = 100;

void ReadInput() {
    cin >> n;

    SeenA.resize(n); SeenB.resize(n);
    for (int i = 0; i < n; ++i) {
        int x; cin >> x;
        if (x) SeenA[x - 1] = true;
    }

    for (int i = 0; i < n; ++i) {
        int x; cin >> x;
        if (x) SeenB[x - 1] = true;
    }
}

void ProcessPlays(bool rev) {
    PlayA.resize(n); PlayB.resize(n);
    for (int i = 0; i < n; ++i) {
        PlayA[i] = (SeenA[i] == rev);
        PlayB[i] = (SeenB[i] != rev);
    }
}

int DP[25][1 << 20];

vector<int> Solve() {
    vector<int> ValuesA, ValuesB;
    for (int i = 0; i < n; ++i) {
        if (PlayA[i]) ValuesA.push_back(i);
        if (PlayB[i]) ValuesB.push_back(i);
    }

    memset(DP, 0, sizeof(DP));
    DP[0][0] = 1;

    int vals = ValuesA.size();
    assert(vals == ValuesB.size());

    for (int old = 0; old < (1 << vals); ++old) {
        int cnt = __builtin_popcount(old);
        for (int ch = 0; ch < vals; ++ch) {
            if (old & (1 << ch)) continue;

            int nw = (old | (1 << ch));
            for (int sfrom = 0, sto = (ValuesA[cnt] > ValuesB[ch]); sfrom <= cnt; ++sfrom, ++sto) {
                add_to(DP[sto][nw], DP[sfrom][old]); 
            }
        }
    }

    vector<int> Ans(n + 1);
    for (int i = 0; i <= n; ++i) {
        Ans[i] = DP[i][(1 << vals) - 1];
    }
    return Ans;
}

int main() {
    // freopen("orice_alt_nume.in", "r", stdin);
    // freopen("orice_alt_nume.out", "w", stdout);
    /// Read the input
    ReadInput();

    /// Make partial answers
    vector<int> PartialAns[2];
    for (int rev = 0; rev < 2; ++rev) {
        ProcessPlays(rev);
        PartialAns[rev] = Solve();
        /*for (auto x : PartialAns[rev]) {
            cerr << x << " ";
        }
        cerr << endl;*/
    }

    int want_score; cin >> want_score;
    int ans = 0;

    /// Merge partial answers into one
    for (int s1 = 0, s2 = want_score; s1 <= want_score; ++s1, --s2) {
        add_to(ans, mul(PartialAns[0][s1], PartialAns[1][s2]));
    }

    cout << ans << endl;

    return 0;
}