#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> Left, Right;
int kMagic = 2;
const int kInf = 2e9;

struct Query {
    int l, r, x, y, idx;
};
struct Edge {
    int a, b, take_cost, skip_cost;
};
vector<Query> Queries[200000];
vector<Edge> Edges;
int n;

void AugmDirected(vector<int> &DP, int a, int b, int c) {
    if (DP[a] == kInf)
        return;
    DP[b] = min(DP[b], DP[a] + c);
}
void AugmUndirected(vector<int> &DP, int a, int b, int c) {
    assert(a != b);
    int aux = DP[b];
    AugmDirected(DP, a, b, c);
    swap(aux, DP[b]);
    AugmDirected(DP, b, a, c);
    swap(aux, DP[b]);
}

int SolveBrut(Query q) {
    vector<int> DP(n, kInf);
    DP[q.x] = 0;
    int extra = 0;

    for (int i = q.l; i <= q.r; ++i) {
        auto &e = Edges[i];
        extra += e.skip_cost;
        AugmUndirected(DP, e.a, e.b, e.take_cost - e.skip_cost);
    }
    if (DP[q.y] == kInf)
        return -1;
    return extra + DP[q.y];
}

vector<vector<int>> Aux;
int SolveOptim(int i, vector<int> &Ans) {
    vector<vector<int>> DP(n, vector<int>(n, kInf));

    int pivot = kMagic * (i + 1), at, extra;
    auto NowQs = Queries[i];

    sort(NowQs.begin(), NowQs.end(), [](Query a, Query b) {
        return a.r < b.r;
    });
    at = pivot - 1;
    extra = 0;
    for (int i = 0; i < n; ++i)
        DP[i][i] = 0;

    auto AugmEdge = [&](Edge e) {
        assert(e.a != e.b);
        extra += e.skip_cost;
        for (int i = 0; i < n; ++i)
            AugmUndirected(DP[i], e.a, e.b, e.take_cost - e.skip_cost);
    };

    for (int i = 0; i < NowQs.size(); ++i) {
        auto &q = NowQs[i];
        auto &aux = Aux[q.idx];

        assert(q.l < pivot && q.l >= pivot - kMagic);
        assert(q.r >= pivot);

        while (at != q.r)
            AugmEdge(Edges[++at]);

        Ans[q.idx] += extra;
        for (int i = 0; i < n; ++i) {
            aux[i] = DP[i][q.y];
        }
    }

    sort(NowQs.begin(), NowQs.end(), [](Query a, Query b) {
        return a.l > b.l;
    });
    at = pivot;
    DP = vector<vector<int>>(n, vector<int>(n, kInf));
    extra = 0;
    for (int i = 0; i < n; ++i)
        DP[i][i] = 0;


    for (int i = 0; i < NowQs.size(); ++i) {
        auto &q = NowQs[i];
        auto &aux = Aux[q.idx];

        while (at != q.l)
            AugmEdge(Edges[--at]);

        Ans[q.idx] += extra;
        int add = kInf;
        for (int i = 0; i < n; ++i) {
            if (aux[i] == kInf || DP[i][q.x] == kInf)
                continue;
            add = min(add, aux[i] + DP[i][q.x]);
        }

        if (add == kInf)
            Ans[q.idx] = -1;
        else Ans[q.idx] += add;
    }
}


#define DIM 1000000
char buff[DIM];
int poz = 0;

void citeste(int &numar)
{
    numar = 0;
    //cat timp caracterul din buffer nu e cifra ignor
    while (buff[poz] < '0' || buff[poz] > '9')
        //daca am "golit" bufferul atunci il umplu
        if (++poz == DIM)
            fread(buff, 1, DIM, stdin), poz = 0;
    //cat timp dau de o cifra recalculez numarul
    while ('0' <= buff[poz] && buff[poz] <= '9')
    {
        numar = numar * 10 + buff[poz] - '0';
        if (++poz == DIM)
            fread(buff, 1, DIM, stdin), poz = 0;
    }
}

int main() {
    ios::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
    freopen("razbunare.in", "r", stdin);
    freopen("razbunare.out", "w", stdout);
#endif

    int m, q;
    // cin >> n >> m >> q;
    citeste(n);
    citeste(m);
    citeste(q);
    kMagic = 4 * m * sqrt(1.0 * n / q) + 1;
    // kMagic = 173;

    Edges.resize(m);
    for (auto &e : Edges) {
        // cin >> e.a >> e.b >> e.take_cost >> e.skip_cost;
        citeste(e.a);
        citeste(e.b);
        citeste(e.take_cost);
        citeste(e.skip_cost);
        e.a -= 1; e.b -= 1;
    }

    vector<int> Ans(q);
    Aux = vector<vector<int>>(q, vector<int>(n, 0));

    for (int i = 0; i < q; ++i) {
        int l, r, x, y;
        //cin >> x >> y >> l >> r;
        citeste(x);
        citeste(y);
        citeste(l);
        citeste(r);
        Query q{l - 1, r - 1, x - 1, y - 1, i};

        int lb = q.l / kMagic;
        int rb = q.r / kMagic;

        if (lb == rb) {
            Ans[i] = SolveBrut(q);
        } else {
            Queries[lb].push_back(q);
        }
    }

    for (int i = 0; i < m; ++i) {
        if (Queries[i].empty())
            continue;
        SolveOptim(i, Ans);
    }

    for (auto ans : Ans)
        cout << ans << '\n';

    return 0;
}