/*Patrick Catalin Alexandru Sava
Atooom Industry and Resources SRL
University of Bucharest
Expected : 100 points*/

#include <fstream>
#include <vector>
#include <cassert>
#include <algorithm>

using namespace std ;

const int NMAX = 3e1 ;
const int LMAX = 3e4 ;
const int QMAX = 3e5 ;
const int CMAX = 1e4 ;
const int INFF = 1e9 ;

ifstream cin ("razbunare.in") ;
ofstream cout ("razbunare.out") ;

bool isBetween (int inf, int number, int sup) {
	return inf <= number and number <= sup ;
}

class Edge
{
public:
	Edge () {}
	Edge (int x, int y, int c, int r)
	{
		this -> x = x ;
		this -> y = y ;
		this -> c = c ;
		this -> r = r ;
	}
	int x, y, c, r ;
};

class Query
{
public:
	Query() {}
	Query (int x, int y, int a, int b)
	{
		this -> x = x ;
		this -> y = y ;
		this -> a = a ;
		this -> b = b ;
	}
	int x, y, a, b ;
};

int Dp [NMAX + 1][NMAX + 1] ;
int Mat [QMAX + 1][NMAX + 1] ;
vector <int> Aux ;
vector <int> Aux2 ;

void Divide (int st, int dr, int n, vector <Edge> &S, vector <Query> &Q, vector <vector <int>> &Qst, vector <vector <int>> &Qdr, vector <int> &Ans)
{
	if (st > dr) {
		return ;
	}
	if (st == dr) {
		while (Qdr [dr].size()) {
			auto elem = Qdr [dr].back() ;
			if (Q[elem].a < st) break ;
			Qdr [dr].pop_back() ;
			Ans [elem] = INFF ;
			if (Q[elem].x == Q[elem].y) {
				Ans [elem] = 0 ;
			}
			else {
				if (Q[elem].x == S [dr].x and Q[elem].y == S [dr].y) {
					Ans [elem] = S [dr].c - S [dr].r ;
				}
				else if (Q[elem].y == S [dr].x and Q[elem].x == S [dr].y) {
					Ans [elem] = S [dr].c - S [dr].r ;
				}
			}
		}
		return ;
	}
	int mij = (st + dr) >> 1 ;
	Divide (st, mij, n, S, Q, Qst, Qdr, Ans) ;
	Divide (mij + 1, dr, n, S, Q, Qst, Qdr, Ans) ;
	for (int i = mij ; i <= dr ; ++ i) {
		for (int j = (int)Qdr[i].size() - 1 ; j >= 0 ; -- j) {
			auto elem = Qdr[i][j] ;
			if (Q[elem].a >= st) {
				Qst[Q[elem].a].push_back (elem) ;
			}
			else {
				break ;
			}
		}
	}
	for (int j = 1 ; j <= n ; ++ j) {
		for (int k = 1 ; k <= n ; ++ k) {
			Dp [j][k] = INFF ;
			if (j == k) {
				Dp [j][k] = 0 ;
			}
		}
	}
	for (int i = mij ; i >= st ; -- i) {
		if (i == mij) {
			Dp [S[mij].x][S[mij].y] = min (S [mij].c - S [mij].r, Dp [S[mij].x][S[mij].y]) ;
			Dp [S[mij].y][S[mij].x] = min (S [mij].c - S [mij].r, Dp [S[mij].y][S[mij].x]) ;
		}
		else {
			for (int j = 1 ; j <= n ; ++ j) {
				Aux [j] = Dp [j][S[i].x] ;
				Aux2 [j] = Dp [j][S[i].y] ;
			}
			for (int j = 1 ; j <= n ; ++ j) {
				if (Dp [j][S[i].y] != INFF) {
					Dp [j][S[i].x] = min (Aux2 [j] + S [i].c - S [i].r, Dp [j][S[i].x]) ;
				}
				if (Dp [j][S[i].x] != INFF) {
					Dp [j][S[i].y] = min (Aux [j] + S [i].c - S [i].r, Dp [j][S[i].y]) ;
				}
			}
		}
		for (auto elem : Qst [i]) {
			for (int j = 1 ; j <= n ; ++ j) {
				Mat [elem][j] = Dp[j][Q[elem].x] ;
			}
		}
		Qst [i].clear() ;
	}
	for (int j = 1 ; j <= n ; ++ j) {
		for (int k = 1 ; k <= n ; ++ k) {
			Dp [j][k] = INFF ;
			if (j == k) {
				Dp [j][k] = 0 ;
			}
		}
	}
	for (int i = mij + 1 ; i <= dr ; ++ i) {
		if (i == mij + 1) {
			Dp [S[mij + 1].x][S[mij + 1].y] = min(S [mij + 1].c - S [mij + 1].r, Dp [S[mij + 1].x][S[mij + 1].y]) ;
			Dp [S[mij + 1].y][S[mij + 1].x] = min(S [mij + 1].c - S [mij + 1].r, Dp [S[mij + 1].y][S[mij + 1].x]) ;
		}
		else {
			for (int j = 1 ; j <= n ; ++ j) {
				Aux [j] = Dp [j][S[i].x] ;
				Aux2 [j] = Dp [j][S[i].y] ;
			}
			for (int j = 1 ; j <= n ; ++ j) {
				if (Dp [j][S[i].y] != INFF) {
					Dp [j][S[i].x] = min (Aux2 [j] + S [i].c - S [i].r, Dp [j][S[i].x]) ;
				}
				if (Dp [j][S[i].x] != INFF) {
					Dp [j][S[i].y] = min (Aux [j] + S [i].c - S [i].r, Dp [j][S[i].y]) ;
				}
			}
		}
		while (Qdr [i].size() and Q [Qdr[i].back()].a >= st) {
			auto elem = Qdr[i].back() ;
			Ans [elem] = INFF ;
			for (int j = 1 ; j <= n ; ++ j) {
				if (Mat [elem][j] != INFF and Dp [j][Q[elem].y] != INFF) {
					Ans [elem] = min (Mat [elem][j] + Dp [j][Q[elem].y], Ans [elem]) ;
				}
			}
			Qdr[i].pop_back() ;
		}
	}
}

int main(int argc, char const *argv[])
{
	int n, l, q ;
	assert(cin >> n >> l >> q) ;
	assert (isBetween (2, n, NMAX)) ;
	assert (isBetween (1, l, LMAX)) ;
	assert (isBetween (1, q, QMAX)) ;
	Aux.resize (n + 1) ;
	Aux2.resize (n + 1) ;
	vector <Edge> S (l + 1) ;
	vector <int> partial_sum (l + 1, 0) ;
	for (int i = 1 ; i <= l ; ++ i) {
		int x, y, c, r ;
		assert (cin >> x >> y >> c >> r) ;
		assert (isBetween(1, x, n)) ;
		assert (isBetween(1, y, n)) ;
		assert (isBetween(0, c, CMAX)) ;
		assert (isBetween(0, r, CMAX)) ;
		assert (x != y) ;
		S [i] = {x, y, c, r} ;
		partial_sum [i] = partial_sum [i - 1] + r ;
	}
	vector <Query> Q (q + 1) ;
	vector <vector <int>> Qst (l + 1, vector <int> ()) ;
	vector <vector <int>> Qdr (l + 1, vector <int> ()) ;
	for (int i = 1 ; i <= q ; ++ i) {
		int x, y, a, b ;
		assert (cin >> x >> y >> a >> b) ;
		assert (isBetween(1, x, n)) ;
		assert (isBetween(1, y, n)) ;
		assert (isBetween(1, a, l)) ;
		assert (isBetween(1, b, l)) ;
		assert (a <= b) ;
		Qdr[b].push_back (i) ;
		Q [i] = {x, y, a, b} ;
	}
	for (int i = 1 ; i <= l ; ++ i) {
		sort (Qdr[i].begin(), Qdr[i].end(), [&Q](const int &current, const int &other) -> bool
		{
			return Q[current].a < Q [other].a ;
		});
	}
	vector <int> Ans (q + 1, -1) ;
	Divide (1, l, n, S, Q, Qst, Qdr, Ans) ;
	for (int i = 1 ; i <= q ; ++ i) {
		if (Ans [i] == INFF) {
			cout << -1 << '\n' ;
		}
		else {
			cout << Ans [i] + partial_sum [Q[i].b] - partial_sum [Q[i].a - 1] << '\n' ;
		}
	}
	return 0;
}