//O(L*logL*N + Q*(Log + N) )

#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define pb push_back
#define ll long long

const int NMAX = 30;
const int LMAX = 3 * 1e4;
const int QMAX = 3 * 1e5;
const int COSTMAX = 1e4;

const int nmax = NMAX + 5;
const int lmax = LMAX + 10;
const int qmax = QMAX + 10;
const int inf = (1 << 30);
int n, L, Q;
int dpSt[nmax][nmax], dpDr[nmax][nmax];
int partialSums[lmax];
int auxX[nmax], auxY[nmax];

struct Edge {
	int x, y, c, r;
	Edge() {}
	Edge(int x, int y, int c, int r): x(x), y(y), c(c), r(r) {

	}
};
struct Query {
	int x, y, a, b, initPos;
	Query() {
	}
	Query(int x, int y, int a, int b, int initPos): x(x), y(y), a(a), b(b), initPos(initPos) {}
};

Edge SS2[lmax];
Query queries[qmax];
int ans[qmax];
vector<int> rightToQuery[qmax];
vector<int> leftToQuery[lmax];

int dpStartDr[qmax][nmax];// costul minim de a ajunge in b(din al j-lea query) stiind ca am pornit din nodul i

void update(int &x, int y) {
	x = min(x, y);
}

int getSum(int st, int dr) {
	return partialSums[dr] - partialSums[st - 1];
}

void go(int st, int dr) {
	if (st > dr) {
		return;
	}
	int mij = (st + dr) / 2;
	// dpSt[i][j] = costul minim pentru a ajunge din i in j stiind ca ma uit la muchiile din mij -> st;
	// dpDr[i][j] = costul minim pentru a anunge din i in j stiind ca ma uit la muchiile din mij -> dr;
	for (int i = 0; i < nmax; ++i) {
		for (int j = 0; j < nmax; ++j) {
			dpSt[i][j] = inf;
			dpDr[i][j] = inf;
		}
	}

	for (int i = mij + 1; i <= dr; ++i) {
		if (i == mij + 1) {
			int ce = mij + 1;
			int x = SS2[ce].x;
			int y = SS2[ce].y;
			dpDr[x][y] = SS2[ce].c;
			dpDr[y][x] = SS2[ce].c;
			for (int i = 1; i <= n; ++i) {
				dpDr[i][i] = min(dpDr[i][i], SS2[ce].r);
			}
		} else {
			int x = SS2[i].x;
			int y = SS2[i].y;
			for (int node = 1; node <= n; ++node) {
				auxX[node] = dpDr[node][x];
				auxY[node] = dpDr[node][y];
			}
			for (int sursa = 1; sursa <= n; ++sursa) {
				// sursa -> y -> sursa -> x -> y;
				if (auxX[sursa] != inf) {
					update(dpDr[sursa][y], auxX[sursa] + SS2[i].c);
				}
				// sursa -> x -> sursa->y->x;
				if (auxY[sursa] != inf) {
					update(dpDr[sursa][x], auxY[sursa] + SS2[i].c);
				}
			}
		}

		for (; !rightToQuery[i].empty(); ) {
			auto it = rightToQuery[i].end();
			--it;
			Query *currentQuery = &queries[*it];
			if (currentQuery->a > mij) {
				break;
			}
			int idxQuery = *it;
			int destination = queries[idxQuery].y;
			for (int sursa = 1; sursa <= n; ++sursa) {
				update(dpStartDr[idxQuery][sursa], dpDr[sursa][destination]);
			}
			rightToQuery[i].pop_back();
		}

		for (int nod = 1; nod <= n; ++nod) {
			assert(dpDr[nod][nod] != inf);
		}
	}

	for (int i = mij; i >= st; --i) {
		if (i == mij) {
			int x = SS2[mij].x;
			int y = SS2[mij].y;
			dpSt[x][y] = SS2[mij].c;
			dpSt[y][x] = SS2[mij].c;
			for (int i = 1; i <= n; ++i) {
				update(dpSt[i][i], SS2[mij].r);
			}
			for (int i = 1; i <= n; ++i) {
				assert(dpSt[i][i] != inf);
			}
		} else {
			//actualizez dinamia in stanga
			int x = SS2[i].x;
			int y = SS2[i].y;
			for (int node = 1; node <= n; ++node) {
				auxX[node] = dpSt[x][node];
				auxY[node] = dpSt[y][node];
			}
			for (int sursa = 1; sursa <= n; ++sursa) {
				// vreau sa merg din x in sursa trecand prin y;
				// x -> sursa
				// x -> y -> sursa;
				if (auxY[sursa] != inf) {
					update(dpSt[x][sursa], auxY[sursa] + SS2[i].c);
				}
				// vreau sa merg din y in sursa trecand prin x;
				// y->sursa ->
				// y -> x -> sursa
				if (auxX[sursa] != inf) {
					update(dpSt[y][sursa], auxX[sursa] + SS2[i].c);
				}
			}
			for (int nod = 1; nod <= n; ++nod) {
				assert(dpSt[nod][nod] != inf);
			}
		}
		//rezolv query-uruile cu capatul stanga in i-ul curent;
		if (leftToQuery[i].empty()) {
			continue;
		}
		for (; !leftToQuery[i].empty(); ) {
			auto it = leftToQuery[i].end();
			--it;
			int currIdxQuery = *it;
			Query *currentQuery = &queries[currIdxQuery];
			int rightSide = currentQuery -> b;
			if (rightSide < mij) {
				break;
			}
			int initPos = currentQuery->initPos;
			int x = currentQuery->x;
			int y = currentQuery->y;
			if (rightSide == mij) {
				if (dpSt[x][y] != inf) {
					ans[ initPos ] = dpSt[x][y] + getSum(currentQuery->a, mij);
				}
			} else {
				ans[initPos] = inf;
				for (int middle = 1; middle <= n; ++middle) {
					if (dpSt[x][middle] != inf && dpStartDr[currIdxQuery][middle] != inf) {
						ans[initPos] = min(ans[initPos],
						                   dpSt[x][middle] + getSum(currentQuery->a, mij) + dpStartDr[currIdxQuery][middle] + getSum(mij + 1, rightSide));
					}
				}
			}
			leftToQuery[i].pop_back();
		}
	}
	if (st != dr) go(st, mij);
	if (st != dr) go(mij + 1, dr);
}

bool cmp(const int &idx1, const int &idx2 ) {
	assert(1 <= idx1 && idx1 <= Q);
	assert(1 <= idx2 && idx2 <= Q);
	return queries[idx1].b < queries[idx2].b;
}


bool cmp2(const int &idx1, const int &idx2) {
	assert(1 <= idx1 && idx1 <= Q);
	assert(1 <= idx2 && idx2 <= Q);

	return queries[idx1].a > queries[idx2].a;
}

int getMaxInt() {
	return std::numeric_limits<int>::max();
}

int main() {
	ios::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
	freopen("razbunare.in", "r", stdin);
	freopen("razbunare.out", "w", stdout);
#endif

	cin >> n >> L >> Q;
	assert(2 <= n && n <= NMAX);
	assert(1 <= L && L <= LMAX);
	assert(1 <= Q && Q <= QMAX);

	for (int i = 1; i <= L; ++i) {
		int x, y, c, r;
		cin >> x >> y >> c >> r;
		assert(1 <= x && x <= n);
		assert(1 <= y && y <= n);
		assert(0 <= c && c <= COSTMAX);
		assert(0 <= r && r <= COSTMAX);
		assert(x != y);

		SS2[i] = Edge(x, y, c - r, 0);
		partialSums[i] = partialSums[i - 1] + r;
		assert(partialSums[i] >= 0 && partialSums[i] <= getMaxInt());
	}

	for (int i = 1; i <= Q; ++i) {
		int x, y, a, b;
		cin >> x >> y >> a >> b;
		assert(1 <= x && x <= n);
		assert(1 <= y && y <= n);
		assert(1 <= a && a <= L);
		assert(1 <= b && b <= L);
		assert(a <= b);
		queries[i] = Query(x, y, a, b, i);
		rightToQuery[b].pb(i);
		leftToQuery[a].pb(i);
		ans[i] = inf;
	}

	for (int i = 1; i <= L; ++i) {
		sort(leftToQuery[i].begin(), leftToQuery[i].end(), cmp);
		sort(rightToQuery[i].begin(), rightToQuery[i].end(), cmp2);
	}

	for (int i = 0; i < qmax; ++i) {
		for (int j = 0; j < nmax; ++j) {
			dpStartDr[i][j] = inf;
		}
	}
	go(1, L);

	for (int i = 1; i <= Q; ++i) {
		ans[i] = (ans[i] == inf ? -1 : ans[i]);
		assert(ans[i] >= -1);
		cout << ans[i] << "\n";
	}
	return 0;
}