//O(L*logL*N^2 + Q*(Log + N) )

#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define pb push_back
#define ll long long

const int NMAX = 30;
const int LMAX = 3 * 1e4;
const int QMAX = 3 * 1e5;

const int nmax = NMAX + 10;
const int lmax = LMAX + 10;
const int qmax = QMAX + 10;
const int inf = (1 << 29);
int n, L, Q;
int dpSt[nmax][nmax], dpDr[nmax][nmax];
int temp[nmax][nmax];

struct Edge {
	int x, y, c, r;
	Edge() {}
	Edge(int x, int y, int c, int r): x(x), y(y), c(c), r(r) {

	}
};
struct Query {
	int x, y, a, b, initPos;
	Query() {
	}
	Query(int x, int y, int a, int b, int initPos): x(x), y(y), a(a), b(b), initPos(initPos) {}
};

Edge s[lmax];
Query queries[qmax];
int ans[qmax];
vector<int> rightToQuery[lmax];
vector<int> leftToQuery[lmax];

int dpStartDr[qmax][nmax];// costul minim de a ajunge in b(din al j-lea query) stiind ca am pornit din nodul i


void update(int &x, int y) {
	x = min(x, y);
}

void assign(int from[][nmax], int to[][nmax]) {
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			to[i][j] = from[i][j];
		}
	}
}

void go(int st, int dr) {
	if (st > dr) {
		return;
	}
	int mij = (st + dr) / 2;
	// dpSt[i][j] = costul minim pentru a ajunge din i in j stiind ca ma uit la muchiile din mij -> st;
	// dpDr[i][j] = costul minim pentru a anunge din i in j stiind ca ma uit la muchiile din mij -> dr;
	for (int i = 0; i < nmax; ++i) {
		for (int j = 0; j < nmax; ++j) {
			dpSt[i][j] = inf;
			dpDr[i][j] = inf;
		}
	}
	int ce = mij + 1;
	int x = s[ce].x;
	int y = s[ce].y;
	dpDr[x][y] = s[ce].c;
	dpDr[y][x] = s[ce].c;
	for (int i = 1; i <= n; ++i) {
		dpDr[i][i] = min(dpDr[i][i], s[ce].r);
	}


	for (; !rightToQuery[ce].empty(); ) {
		auto it = rightToQuery[ce].end();
		--it;
		Query *currentQuery = &queries[*it];
		if (currentQuery->a > mij) {
			break;
		}
		int idxQuery = *it;
		int destination = queries[idxQuery].y;
		for (int node = 1; node <= n; ++node) {
			update(dpStartDr[idxQuery][node], dpDr[node][destination]);
		}
		rightToQuery[ce].pop_back();
	}


	for (int i = 1; i <= n; ++i) {
		assert(dpDr[i][i] != inf);
	}
	assign(dpDr, temp);
	for (int i = ce + 1; i <= dr; ++i) {
		int x = s[i].x;
		int y = s[i].y;
		for (int z = 1; z <= n; ++z) {
			for (int t = 1; t <= n; ++t) {
				dpDr[z][t] = inf;
				if (temp[z][t] != inf) {
					dpDr[z][t] = temp[z][t] + s[i].r;
				}
			}
		}

		for (int sursa = 1; sursa <= n; ++sursa) {
			// sursa -> y -> sursa -> x -> y;
			if (temp[sursa][x] != inf) {
				update(dpDr[sursa][y], temp[sursa][x] + s[i].c);
			}
			// sursa -> x -> sursa->y->x;
			if (temp[sursa][y] != inf) {
				update(dpDr[sursa][x], temp[sursa][y] + s[i].c);
			}
		}


		for (; !rightToQuery[i].empty(); ) {
			auto it = rightToQuery[i].end();
			--it;
			Query *currentQuery = &queries[*it];
			if (currentQuery->a > mij) {
				break;
			}
			int idxQuery = *it;
			int destination = queries[idxQuery].y;

			for (int sursa = 1; sursa <= n; ++sursa) {
				update(dpStartDr[idxQuery][sursa], dpDr[sursa][destination]);
			}
			rightToQuery[i].pop_back();
		}

		for (int nod = 1; nod <= n; ++nod) {
			assert(dpDr[nod][nod] != inf);
		}
		assign(dpDr, temp);

	}

	for (int i = mij; i >= st; --i) {
		if (i == mij) {
			int x = s[mij].x;
			int y = s[mij].y;
			dpSt[x][y] = s[mij].c;
			dpSt[y][x] = s[mij].c;
			for (int i = 1; i <= n; ++i) {
				update(dpSt[i][i], s[mij].r);
			}
			for (int i = 1; i <= n; ++i) {
				assert(dpSt[i][i] != inf);
			}
			assign(dpSt, temp);
		} else {
			//actualizez dinamia in stanga
			int x = s[i].x;
			int y = s[i].y;
			for (int z = 1; z <= n; ++z) {
				for (int t = 1; t <= n; ++t) {
					dpSt[z][t] = inf;
					if (temp[z][t] != inf) {
						update(dpSt[z][t], temp[z][t] + s[i].r);
					}
				}
			}
			for (int sursa = 1; sursa <= n; ++sursa) {
				// vreau sa merg din x in sursa trecand prin y;
				// x -> sursa
				// x -> y -> sursa;
				if (temp[y][sursa] != inf) {
					update(dpSt[x][sursa], temp[y][sursa] + s[i].c);
				}
				// vreau sa merg din y in sursa trecand prin x;
				// y->sursa ->
				// y -> x -> sursa
				if (temp[x][sursa] != inf) {
					update(dpSt[y][sursa], temp[x][sursa] + s[i].c);
				}
			}
			for (int nod = 1; nod <= n; ++nod) {
				assert(dpSt[nod][nod] != inf);
			}
			assign(dpSt, temp);
		}
		//rezolv query-uruile cu capatul stanga in i-ul curent;
		if (leftToQuery[i].empty()) {
			continue;
		}
		for (; !leftToQuery[i].empty(); ) {
			auto it = leftToQuery[i].end();
			--it;
			int currIdxQuery = *it;
			Query *currentQuery = &queries[currIdxQuery];
			int rightSide = currentQuery -> b;
			if (rightSide < mij) {
				break;
			}
			int initPos = currentQuery->initPos;
			int x = currentQuery->x;
			int y = currentQuery->y;
			if (rightSide == mij) {
				ans[ initPos ] = dpSt[x][y];
			} else {
				ans[initPos] = inf;
				for (int middle = 1; middle <= n; ++middle) {
					if (dpSt[x][middle] != inf && dpStartDr[currIdxQuery][middle] != inf) {
						ans[initPos] = min(ans[initPos],
						                   dpSt[x][middle] + dpStartDr[currIdxQuery][middle]);
					}
				}
			}
			leftToQuery[i].pop_back();
		}
	}
	if (st != dr) go(st, mij);
	if (st != dr) go(mij + 1, dr);
}

bool cmp(const int &idx1, const int &idx2 ) {
	return queries[idx1].b < queries[idx2].b;
}

bool cmp2(const int &idx1, const int &idx2) {
	return queries[idx1].a > queries[idx2].a;
}


#define DIM 1000000
char buff[DIM];
int poz = 0;

void citeste(int &numar)
{
	numar = 0;
	//cat timp caracterul din buffer nu e cifra ignor
	while (buff[poz] < '0' || buff[poz] > '9')
		//daca am "golit" bufferul atunci il umplu
		if (++poz == DIM)
			fread(buff, 1, DIM, stdin), poz = 0;
	//cat timp dau de o cifra recalculez numarul
	while ('0' <= buff[poz] && buff[poz] <= '9')
	{
		numar = numar * 10 + buff[poz] - '0';
		if (++poz == DIM)
			fread(buff, 1, DIM, stdin), poz = 0;
	}
}

int main() {
	ios::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
	freopen("razbunare.in", "r", stdin);
	freopen("razbunare.out", "w", stdout);
#endif

	// cin >> n >> L >> Q;
	citeste(n);
	citeste(L);
	citeste(Q);
	for (int i = 1; i <= L; ++i) {
		int x, y, c, r;
		citeste(x);
		citeste(y);
		citeste(c);
		citeste(r);
		// cin >> x >> y >> c >> r;
		s[i] = Edge(x, y, c, r);
	}

	for (int i = 1; i <= Q; ++i) {
		int x, y, a, b;
		// cin >> x >> y >> a >> b;
		citeste(x);
		citeste(y);
		citeste(a);
		citeste(b);
		queries[i] = Query(x, y, a, b, i);
		rightToQuery[b].pb(i);
		leftToQuery[a].pb(i);
	}

	for (int i = 1; i <= L; ++i) {
		sort(leftToQuery[i].begin(), leftToQuery[i].end(), cmp);
		sort(rightToQuery[i].begin(), rightToQuery[i].end(), cmp2);
	}
	for (int i = 0; i < qmax; ++i) {
		for (int j = 0; j < nmax; ++j) {
			dpStartDr[i][j] = inf;
		}
	}


	go(1, L);

	for (int i = 1; i <= Q; ++i) {
		ans[i] = (ans[i] == inf ? -1 : ans[i]);
		cout << ans[i] << "\n";
	}
	return 0;
}