/**
 * visanr
 * 100p
 */
#include <bits/stdc++.h>
using namespace std;

const int kNmax = 31;
const int kLmax = 30010;
const int kQmax = 300010;
const int kInf  = 0x3f3f3f3f;
const int DEBUG = 0;

int n, m, q, x[kLmax], y[kLmax], c[kLmax], r[kLmax], sum_r[kLmax];
int ans[kQmax], qx[kQmax], qy[kQmax], qa[kQmax], qb[kQmax];
vector<pair<int, int> > left_end[kLmax], right_end[kLmax];
int dp[kNmax][kNmax], ans_left[kQmax][kNmax], ans_right[kQmax][kNmax];

void solve(int left, int right) {
	if (left > right) {
		return ;
	}

	int mid = (left + right) / 2;
		
	memset(dp, kInf, sizeof(dp));
	for (int node = 1; node <= n; node++) {
		dp[node][node] = 0;
	}

	for (int i = mid + 1; i <= right; i++) {
		if (x[i] == y[i]) {
			dp[x[i]][y[i]] += min(c[i] - r[i], 0);
		} else {
			for (int node = 1; node <= n; node++) {
				int dpx = dp[node][x[i]], dpy = dp[node][y[i]];
				if (dp[node][x[i]] != kInf) {
					dpy = min(dpy, dp[node][x[i]] + c[i] - r[i]);
				}
				if (dp[node][y[i]] != kInf) {
					dpx = min(dpx, dp[node][y[i]] + c[i] - r[i]);
				}
				dp[node][x[i]] = dpx;
				dp[node][y[i]] = dpy;
			}
			dp[x[i]][y[i]] = min(dp[x[i]][y[i]], c[i] - r[i]);
			dp[y[i]][x[i]] = min(dp[y[i]][x[i]], c[i] - r[i]);
		}

		while (!right_end[i].empty()) {
			int left2, idx;
			std::tie(left2, idx) = right_end[i].back();
			if (left2 > mid) {
				break;
			}
			right_end[i].pop_back();
			for (int node = 1; node <= n; node++) {	
				ans_right[idx][node] = dp[node][qy[idx]];
			}
		}
	}

	memset(dp, kInf, sizeof(dp));
	for (int node = 1; node <= n; node++) {
		dp[node][node] = 0;
	}
	for (int i = mid; i >= left; i--) {
		if (x[i] == y[i]) {
			dp[x[i]][y[i]] += min(c[i] - r[i], 0);
		} else {
			for (int node = 1; node <= n; node++) {
				int dpx = dp[x[i]][node], dpy = dp[y[i]][node];
				if (dp[y[i]][node] != kInf) {
					dpx = min(dpx, dp[y[i]][node] + c[i] - r[i]);
				}
				if (dp[x[i]][node] != kInf) {
					dpy = min(dpy, dp[x[i]][node] + c[i] - r[i]);
				}
				dp[x[i]][node] = dpx;
				dp[y[i]][node] = dpy;
			}

			dp[x[i]][y[i]] = min(dp[x[i]][y[i]], c[i] - r[i]);
			dp[y[i]][x[i]] = min(dp[y[i]][x[i]], c[i] - r[i]);
		}

		while (!left_end[i].empty()) {
			int right2, idx;
			std::tie(right2, idx) = left_end[i].back();
			if (right != left && right2 <= mid) {
				break;
			}
			left_end[i].pop_back();
			for (int node = 1; node <= n; node++) {
				ans_left[idx][node] = dp[qx[idx]][node];
			}
		}
	}

	if (left != right) {
		solve(left, mid);
		solve(mid + 1, right);
	}
}

int main() {
	freopen("razbunare.in", "r", stdin);
	freopen("razbunare.out", "w", stdout);

	scanf("%d %d %d", &n, &m, &q);
	for (int i = 1; i <= m; i++) {
		scanf("%d %d %d %d", &x[i], &y[i], &c[i], &r[i]);
		sum_r[i] = sum_r[i - 1] + r[i];
	}
	for (int i = 1; i <= q; i++) {
		scanf("%d %d %d %d", &qx[i], &qy[i], &qa[i], &qb[i]);
		left_end[qa[i]].push_back({qb[i], i});
		right_end[qb[i]].push_back({qa[i], i});
	}

	memset(ans_left, kInf, sizeof(ans_left));
	memset(ans_right, kInf, sizeof(ans_right));

	for (int i = 1; i <= m; i++) {
		sort(left_end[i].begin(), left_end[i].end());
		sort(right_end[i].begin(), right_end[i].end());
		reverse(right_end[i].begin(), right_end[i].end());
	}

	solve(1, m);

	for (int i = 1; i <= q; i++) {
		ans[i] = min(ans_left[i][qy[i]], ans_right[i][qx[i]]);
		for (int node = 1; node <= n; node++) {
			if (ans_left[i][node] != kInf && 
				ans_right[i][node] != kInf) {
				ans[i] = min(ans[i], ans_left[i][node] + ans_right[i][node]);
			}
		}

		if (ans[i] == kInf) {
			printf("-1\n");
		} else {
			printf("%d\n", ans[i] + sum_r[qb[i]] - sum_r[qa[i] - 1]);
		}
	}

	return 0;
}